package plugins;

import java.awt.*;
import java.awt.image.ImageProducer;
import javax.swing.ImageIcon;
import java.net.URL;
import pluginSDK.Obstacle;
import main.Flock;

/**
 * Title:        the Wondrous Farm
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:      minfo
 * @author Guillaume VAILLANT
 * @version 0.8
 */
public class Champignon extends Obstacle {

        private ImageIcon img = null;

        static {
                System.out.println("chargement du plugin d'Obstacle: \"Champignon\"...");
        }

	public Champignon() {
                super();
                this.setHeight(48);
                this.setWidth(48);
        }

        public String getKind() {
                return "Champignon";
        }

        public void drawEntity(Graphics g) {

                if (img == null) {
                        try {
                                URL imgURL = new URL(this.getPath() + "/pict/mush.gif");
                                img = new ImageIcon(imgURL);
                        } catch(Exception e) {
                                System.err.println("[ERR] Exception caught: " + e.getMessage());
	                        e.printStackTrace();
	                }
                }

                if (img != null)
                        g.drawImage(img.getImage(), x - 24 , y - 24, img.getImageObserver());

                if (this.getSelected()) {
                        g.setColor(Color.green);
                        g.drawOval(x - 26, y - 26, 52, 52);
                }
        }
}
