package plugins;

import java.util.ArrayList;
import pluginSDK.*;
import main.*;

/**
 * Title:        the Wondrous Farm<br>
 * Description:	 Vous connaissez la bombe A, a marche pareil :-)<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 * @author Guillaume VAILLANT
 * @version 0.8
 */
public class Hiroshima extends Behaviours {

        static {
                System.out.println("chargement du plugin de comportement: \"Hiroshima\"...");
        }

        public Hiroshima() {}

        public String getBehaviour() {
                return "Hiroshima";
        }

        public boolean actsOn(Boids p, Entity t, Flock f) {

		t = p.seekNearest();

		double d = (t != null) ? p.distanceDepuisUnPoint(t.getPosX(), t.getPosY()) : 0.0;

                if (t != null && // si on a une collision imminente
		    ((t.getType() == Entity.IS_BOID) || (t.getType() == Entity.IS_OBSTACLE)) &&
		    detecteCollision(p, t, f) && (d < f.minDist)) {
		    	f.empty(); // on dtruit tout
			return true;
                }
		return false;
        }

	/**
	 * Dtection de la collision: si au prochain point que 'b' atteint il
	 * se trouve dans 'e', alors il y a collision.
	 * @param b: le boid qui pourrait percuter
	 * @param e: l'entit qui pourrait tre percute
	 * @return boolean: 'true' si collision, 'false' sinon
	 */
        public static boolean detecteCollision(Boids b, Entity e, Flock f) {
		
		int nextX = (b.getPosX() + (int)(Math.cos(b.getHeading()) * b.getSpeed())) % f.getWidth();
		int nextY = (b.getPosY() + (int)(Math.sin(b.getHeading()) * b.getSpeed())) % f.getHeight();

		int xe1 = e.getPosX() - e.getWidth() / 2;
		int xe2 = e.getPosX() + e.getWidth() / 2;
		int ye1 = e.getPosY() - e.getHeight() / 2;
		int ye2 = e.getPosY() + e.getHeight() / 2;

		int xb1 = nextX - b.getWidth() / 2;
		int xb2 = nextX + b.getWidth() / 2;
		int yb1 = nextY - b.getHeight() / 2;
		int yb2 = nextY + b.getHeight() / 2;

		if ((nextX >= xe1 && nextX <= xe2 && nextY >= ye1 && nextY <= ye2) ||
		    (xb1 >= xe1 && xb1 <= xe2 && yb1 >= ye1 && yb1 <= ye2) ||
		    (xb2 >= xe1 && xb2 <= xe2 && yb1 >= ye1 && yb1 <= ye2) ||
		    (xb1 >= xe1 && xb1 <= xe2 && yb2 >= ye1 && yb2 <= ye2) ||
		    (xb2 >= xe1 && xb2 <= xe2 && yb2 >= ye1 && yb2 <= ye2))
			return true;

		return false;
        }

}
