package plugins;

import java.awt.*;
import java.awt.image.ImageProducer;
import javax.swing.ImageIcon;

import java.net.URL;
import java.util.ArrayList;

import pluginSDK.*;
import main.Flock;
import utils.SoundPlayer;
import utils.MyImage;

/**
 * Title:        the Wondrous Farm
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:      minfo
 * @author Guillaume VAILLANT
 * @version 1.0
 */

public class Homer extends Boids {

//        private MyImage img = null;
	private	ImageIcon img = null;
        private SoundPlayer snd = null;
	private Entity p = null;

        static {
                System.out.println("chargement du plugin pour Boids: \"Homer\"...");
        }

        public Homer() {
                super();
                this.setHeight(36);
                this.setWidth(25);
        }

        public String getKind() { return "Homer"; }

        public void extraStuff() {
                if (snd == null) {
                        try {
                                snd = new SoundPlayer(new URL(this.getPath() + "/sounds/Homer.wav"));
                        } catch (Exception e) {
                                System.err.println("[ERR] Exception caught: " + e.getMessage());
                                e.printStackTrace();
                        }
                }
                snd.play();
        }

        public void drawEntity(Graphics g) {
                if (img == null) {
                        try {
                                URL imgURL = new URL(this.getPath() + "/pict/Homer.jpg");
				img = new ImageIcon(imgURL);
                        } catch(Exception e) {
                                System.err.println("[ERR] Exception caught: " + e.getMessage());
	                        e.printStackTrace();
                                System.exit(-10);
	                }
                }

                if (img != null)
			g.drawImage(img.getImage(), x - 12 , y - 18, img.getImageObserver());

                if (this.getSelected()) {
                        g.setColor(Color.green);
                        g.drawOval(x - 20, y - 20, 40, 40);
                }
        }
}
