package plugins;

import java.awt.*;
import pluginSDK.*;
import main.*;

/**
 * Title:        the Wondrous Farm<br>
 * Description:  Un comportement de suivi de chemin<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 * @author Guillaume Vaillant
 * @version 1
 */
 public class PathFollowing extends Behaviours {

 	private Point[] way = null;
	private int num;

 	static {
                System.out.println("chargement du plugin de comportement: \"Suivi de chemin\"...");
        }

	public PathFollowing() { num = 0; }

	public String getBehaviour() { return "PathFollowing"; }

	public boolean actsOn(Boids b, Entity e, Flock f) {
		if (way == null) {
			int nbMaxWp = (int)(Math.random() * 9) + 1;
			way = new Point[nbMaxWp];
			for(int i = 0; i < nbMaxWp; i++)
				way[i] = new Point(
						(int)(Math.random() * (f.getWidth() - 20)) + 10,
						(int)(Math.random() * (f.getHeight() - 20)) + 10
						  );
			num = 0;
		}
		
		if (num < way.length) {
			double nHdg = b.directionVersPoint((int)way[num].getX(), (int)way[num].getY());
                
			b.changeDir(nHdg);
                	b.move();
                	double d = b.distanceDepuisUnPoint((int)way[num].getX(), (int)way[num].getY());

			if (d <= 5.0) {
				if (num != (way.length - 1))
					System.out.println("[" + b.getName() + "] arrived at waypoint #" + num + ".");
				else
					System.out.println("[" + b.getName() + "] ends its way.");
				b.extraStuff();
				num++;
			} else {
				showNextWaypoint(b, f.getGraphics());
				f.repaint();
			}
			return false;	// on veut qd mme pouvoir viter des obstacles
		} else
			return false;
	}

	private void showNextWaypoint(Boids b, Graphics g) {
		showMyWay(g);
		g.setColor(Color.red);
		g.drawLine((int)way[num].getX() - 10, (int)way[num].getY() - 10, (int)way[num].getX() + 10, (int)way[num].getY() + 10);
		g.drawLine((int)way[num].getX() + 10, (int)way[num].getY() - 10, (int)way[num].getX() - 10, (int)way[num].getY() + 10);
		g.setColor(Color.red);
		g.drawLine(b.getPosX(), b.getPosY(), (int)way[num].getX(), (int)way[num].getY());
	}

	private void showMyWay(Graphics g) {
		int x1, y1, x2, y2;
		
		for (int i = num; i < (way.length - 1); i++) {
			x1 = (int)way[i].getX(); y1 = (int)way[i].getY();
			x2 = (int)way[i + 1].getX(); y2 = (int)way[i + 1].getY();
			g.setColor(Color.blue);
			g.drawLine(x1 - 10, y1 - 10, x1 + 10, y1 + 10);
			g.drawLine(x1 + 10, y1 - 10, x1 - 10, y1 + 10);
			g.drawLine(x2 - 10, y2 - 10, x2 + 10, y2 + 10);
			g.drawLine(x2 + 10, y2 - 10, x2 - 10, y2 + 10);
			g.drawLine(x1, y1, x2, y2);
		}
	}

}
