package plugins;

import java.awt.Graphics;
import java.awt.Color;

import pluginSDK.*;
import main.*;

/**
 * Title:        the Wondrous Farm<br>
 * Description:  un Boids avec se comportement se transforme en psychopahe arm d'un fusil laser de grde puissance<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 * @author Guillaume VAILLANT
 * @version 1.0
 */
public class Psychopath extends Behaviours {

        static {
                System.out.println("chargement du plugin de comportement: \"psychopathe\"...");
        }

        public Psychopath() {}

        public String getBehaviour() {
                return "Psychopath";
        }

        public boolean actsOn(Boids p, Entity t, Flock f) {

                if ((f.population() != 1) && (p.canSee(t))) {
                        // je me tourne vers elle
                        double nHdg = t.directionDepuisUnPoint(p.getPosX(), p.getPosY(), p.getHeading());
                        p.changeDir(nHdg);
                        // ja la bouffe si c'est un Boids
                        if (t.getType() == Entity.IS_BOID) {
                                System.out.println("[" + p.getName() + ":] j'ai butt [" + ((Boids)t).getName() + "]");
                                // j'augmente mon nombre de kills
                                p.extraStuff();
				this.shoot(p, (Boids)t, f.getGraphics());
				f.repaint(); // un peu violent, mais c bon pour le moment
                                p.incNbKill();
                                p.move();
                                f.remove(t);
				return true;
                        }
                }
		return false;
        }

	private void shoot(Boids p, Boids t, Graphics g) {
		g.setColor(Color.red);
		g.drawLine(p.getPosX() - 1, p.getPosY() - 1,
			   t.getPosX(), t.getPosY());
		g.drawLine(p.getPosX(), p.getPosY(),
			   t.getPosX(), t.getPosY());
		g.drawLine(p.getPosX() + 1, p.getPosY() + 1,
			   t.getPosX(), t.getPosY());
	}
}
