package plugins;

import java.net.URL;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.ImageIcon;
import java.util.*;
import pluginSDK.*;
import main.*;

/**
 * Title:        the Wondrous Farm
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:      minfo
 * @author Sebastien Forget
 * @version 0.8
 */
public class SebBoid1 extends Boids {
        private ImageIcon img = null;
        static {
	    System.out.println("chargement du plugin pour Boids: \"SebBoid1\"...");
        }

	public SebBoid1() { 
	    super();
	    this.setHeight(32);
	    this.setWidth(32); 
	}

        public String getKind() { return "Insecte"; }

        public void drawEntity(Graphics g) {
	    //Chargement de l'image
	    if (img == null) {
		try {
		    URL imgURL = new URL(this.getPath() + "/pict/bebete1.gif");
		    img = new ImageIcon(imgURL);
		} catch(Exception e) {
		    System.err.println("[ERR] Exception caught: " + e.getMessage());
		    e.printStackTrace();
		    System.exit(-10);
		}
	    }
	    //Affichage de l'image avec rotation selon la direction
	    if (img != null) {
		double angle = (heading+Math.PI/2);
		Graphics2D g2d = (Graphics2D)g;
		AffineTransform at = new AffineTransform();
		at.setToRotation(angle, x, y);
		AffineTransform ati = null;
		try {
		    ati = at.createInverse();
		}
		catch(NoninvertibleTransformException e) {
		    System.out.println("NoninvertibleTransformException !!!");
		}
		g2d.transform(at);
		g2d.drawImage(img.getImage(), x-w/2, y-h/2, img.getImageObserver());
		g2d.transform(ati);
	    }

	    if (this.getSelected()) {
                        g.setColor(Color.green);
                        g.drawOval(x - w/2, y - h/2, w, h);
            }
	}

}
