package plugins;

import java.awt.*;
import pluginSDK.*;
import main.*;

/**
 * Title:        the Wondrous Farm<br>
 * Description:  Un comportement de recherche d'un point<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 * @author Guillaume Vaillant
 * @version 1
 */
 public class Seeker extends Behaviours {

 	private int wpX, wpY;
	private static int num;
	private String wpN = null;

 	static {
                System.out.println("chargement du plugin de comportement: \"Recherche\"...");
		num = 0;
        }

	public Seeker() {}

	public String getBehaviour() { return "Seeker"; }

	public boolean actsOn(Boids b, Entity e, Flock f) {
		if (wpN == null) {
			wpX = (int)(Math.random() * (f.getWidth() - 20)) + 10;
			wpY = (int)(Math.random() * (f.getHeight() - 20)) + 10;
			wpN = new String (b.getName() + "_wp_" + num++);
		}
		double nHdg = b.directionVersPoint(wpX, wpY);
                
		b.changeDir(nHdg);
                b.move();
                double d = b.distanceDepuisUnPoint(wpX, wpY);

		if (d <= 5.0) {
			System.out.println("[" + b.getName() + "] est arriv  [" + wpN + "]");
			b.extraStuff();
			wpN = null;
		} else {
			showMyWay(b, f.getGraphics());
			f.repaint();
		}
		return false; // il avence tjs vers sa cible, mais il doit pouvoir viter des obstacles
	}

	private void showMyWay(Boids b, Graphics g) {
		g.setColor(Color.red);
		g.drawLine(wpX - 10, wpY - 10, wpX + 10, wpY + 10);
		g.drawLine(wpX + 10, wpY - 10, wpX - 10, wpY + 10);
		g.setColor(Color.blue);
		g.drawLine(b.getPosX(), b.getPosY(), wpX, wpY);
	}
}
