package plugins;

import pluginSDK.*;
import main.*;

/**
 * Title:        the Wondrous Farm
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:      minfo
 * @author Sbastien Forget
 * @version 0.8
 */

public class SerialKiller extends Behaviours {
    private Boids victime = null;
    static {
	System.out.println("chargement du plugin de comportement: \"Tueur en sries\"...");
    }

    public SerialKiller() {}

    public String getBehaviour() {
	return "SerialKiller";
    }

    public boolean actsOn(Boids p, Entity t, Flock f) {
	//Si je n'ai pas de victime j'en cherche une
	if ((victime == null) && (f.population() != 1) && (p.canSee(t))) {
	    if (t.getType() == Entity.IS_BOID) {
		victime = (Boids)t;
	    }
	}
	if (victime!=null) {
	    //je me dirige vers elle
	    double nHdg = p.directionVersPoint(victime.getPosX(),
					       victime.getPosY());
	    p.changeDir(nHdg);
	    //je fonce dessus
	    p.move(2);
	    //Si je suis assez prs, je la mange
	    double d = p.distanceDepuisUnPoint(victime.getPosX(), victime.getPosY());
	    if (d <= 4.0) {
		System.out.println("[" + p.getName() + ":] j'ai bouff [" + ((Boids)t).getName() + "]");
		// j'augmente mon nombre de kills
		p.extraStuff();
		p.incNbKill();
		f.remove(t);
		victime = null;
	    }
	    return true;
	}
	return false;
    }
}
