package GUI;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.net.URL;

import pluginSDK.*;
import main.*;
import utils.*;
import classLoader.*;

/**
 * Title:        the Wondrous Farm<br>
 * Description: La classe du Wizard pour crer des entits.<br>
 * Copyright:    Copyright (c) 2002
 * Company:      minfo
 */
public class EntityCreator extends JInternalFrame {
        JPanel jPanel1 = new JPanel();
        JPanel jPanel2 = new JPanel();
        JPanel jPanel3 = new JPanel();
        JButton cancelBtn = new JButton();
        JButton addBtn = new JButton();
        JLabel jLabel1 = new JLabel();
        JLabel jLabel2 = new JLabel();
        JList obstacles = new JList();
        JLabel jLabel5 = new JLabel();
        JList behaviours = new JList();
        JList boids = new JList();
        JLabel jLabel3 = new JLabel();
        JLabel jLabel4 = new JLabel();
        GridBagLayout gridBagLayout2 = new GridBagLayout();
        JLabel jLabel6 = new JLabel();
        JLabel jLabel7 = new JLabel();
        JTextField baseName = new JTextField();
        JSlider nbEntities = new JSlider(1, 50, 5);
        GridBagLayout gridBagLayout4 = new GridBagLayout();
        JInternalFrame me;
        private MyClassLoader cl;
        private Flock f;
        private int boidNum;
        JButton refreshBtn = new JButton();
        GridBagLayout gridBagLayout1 = new GridBagLayout();
        JLabel jLabel8 = new JLabel();
        GridBagLayout gridBagLayout3 = new GridBagLayout();
	private Behaviours defaultBoidsBehaviour;
	private Package pack = null;

        public MyClassLoader getLoader() { return cl; }

        private void refreshPluginsLists() {

		ArrayList bo = new ArrayList(), be = new ArrayList(), ob = new ArrayList();
                ArrayList listeP = null;
                Configurator conf = new Configurator("file:plugins.conf");
                String[] pps = conf.getPluginsPath();

                for (int k = 0; k < pps.length; k++) {
                        cl = new MyClassLoader(pps[k], null, pack);
                        listeP = cl.loadPlugins2();
                        for(int i = 0; i < listeP.size(); i++) {
                                Plugin p = (Plugin)listeP.get(i);
                                int t = p.getType();
                                switch (t) {
                                case Entity.IS_BOID:
                                        ((Boids)p).setPath(pps[k]);
                        	        bo.add(p);
                                        break;
                                case Entity.IS_BEHAVIOUR:
					if (((Behaviours)p).getBehaviour().compareTo("Aleatoire") == 0)
						defaultBoidsBehaviour = (Behaviours)p;
                                        be.add(p);
                                        break;
                                case Entity.IS_OBSTACLE:
                                        ((Obstacle)p).setPath(pps[k]);
                                        ob.add(p);
                                        break;
                                default:
                                        System.err.println("[ERR] not a valid plugin: " + listeP.get(i));
                                }
		        }
                }

		Object[] boP = bo.toArray();
		Arrays.sort(boP, new Comparator() {
			public int compare(Object s1, Object s2) {
				return s1.toString().compareTo(s2.toString());
			}
			public boolean equals(Object o) {
				return this.toString().compareTo(o.toString()) == 0;
			}
		});
		boids.setListData(boP);

		Object[] beP = be.toArray();
		Arrays.sort(beP, new Comparator() {
			public int compare(Object s1, Object s2) {
				return s1.toString().compareTo(s2.toString());
			}
			public boolean equals(Object o) {
				return this.toString().compareTo(o.toString()) == 0;
			}
		});
		behaviours.setListData(beP);

		Object[] obP = ob.toArray();
		Arrays.sort(obP, new Comparator() {
			public int compare(Object s1, Object s2) {
				return s1.toString().compareTo(s2.toString());
			}
			public boolean equals(Object o) {
				return this.toString().compareTo(o.toString()) == 0;
			}
		});
		obstacles.setListData(obP);
        }

        public EntityCreator(Flock f) {

		defaultBoidsBehaviour = null;

                this.f = f;
                boidNum = 0;

		nbEntities.setMaximum(50);
                nbEntities.setMinorTickSpacing(1);
                nbEntities.setPaintLabels(true);
                nbEntities.setPaintTicks(true);
		nbEntities.createStandardLabels(1);
                nbEntities.setForeground(Color.black);
                nbEntities.setBorder(BorderFactory.createLoweredBevelBorder());

		refreshPluginsLists();

                try {
                        jbInit();
                }
                catch(Exception e) {
                        e.printStackTrace();
                }
                this.setSize(640, 480);
                me = this;
                this.setVisible(true);
                addBtn.setIcon(new ImageIcon("icons/yes.gif"));
                addBtn.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                createEntities();
                                me.toBack();
				try {
					me.setSelected(false);
				} catch (Exception x) {
					System.err.println("[ERR] Exception caught: " + x.getMessage());
				}
                        }
                });

                cancelBtn.setIcon(new ImageIcon("icons/no.gif"));
                cancelBtn.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                me.toBack();
				try {
					me.setSelected(false);
				} catch (Exception x) {
					System.err.println("[ERR] Exception caught: " + x.getMessage());
				}
                        }
                });
                nbEntities.setPaintLabels(true);
                nbEntities.setValue(1);
                nbEntities.addChangeListener(new ChangeListener() {
                        public void stateChanged(ChangeEvent e) {
                                ((JComponent)e.getSource()).setToolTipText("" + ((JSlider)e.getSource()).getValue());
                        }
                });

                refreshBtn.setIcon(new ImageIcon("icons/refresh.gif"));

		boids.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		boids.addListSelectionListener(new PluginSelector(obstacles));
		behaviours.addListSelectionListener(new PluginSelector(obstacles));
		obstacles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		obstacles.addListSelectionListener(new PluginSelector(boids, behaviours));
        }

        private void jbInit() throws Exception {
                this.getContentPane().setBackground(Color.lightGray);
                this.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
                this.setIconifiable(true);
                this.setMaximizable(true);
                this.setClosable(false);
                this.setIcon(true);
                this.setTitle("Entity Creator Wizard");
                this.getContentPane().setLayout(gridBagLayout1);
                jPanel1.setBackground(Color.lightGray);
                jPanel1.setMaximumSize(new Dimension(640, 60));
                jPanel1.setMinimumSize(new Dimension(640, 60));
                jPanel1.setPreferredSize(new Dimension(640, 60));
                jPanel1.setLayout(gridBagLayout3);
                jPanel2.setBackground(Color.lightGray);
                jPanel2.setMaximumSize(new Dimension(640, 290));
                jPanel2.setMinimumSize(new Dimension(640, 290));
                jPanel2.setPreferredSize(new Dimension(640, 290));
                jPanel2.setLayout(gridBagLayout2);
                jPanel3.setBackground(Color.lightGray);
                jPanel3.setMaximumSize(new Dimension(640, 50));
                jPanel3.setMinimumSize(new Dimension(640, 50));
                jPanel3.setPreferredSize(new Dimension(640, 50));
                jPanel3.setLayout(gridBagLayout4);
                cancelBtn.setToolTipText("Cancel, go back to simualtion");
                cancelBtn.setMaximumSize(new Dimension(32, 32));
                cancelBtn.setMinimumSize(new Dimension(32, 32));
                cancelBtn.setPreferredSize(new Dimension(32, 32));
                addBtn.setMaximumSize(new Dimension(32, 32));
                addBtn.setMinimumSize(new Dimension(32, 32));
                addBtn.setPreferredSize(new Dimension(32, 32));
                addBtn.setToolTipText("Add selected entities to world");
                jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel1.setText("Add entities to world");
                jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel2.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel2.setText("Cancel");
                jLabel5.setMaximumSize(new Dimension(210, 15));
                jLabel5.setMinimumSize(new Dimension(210, 15));
                jLabel5.setPreferredSize(new Dimension(210, 15));
                jLabel5.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel5.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel5.setLabelFor(boids);
                jLabel5.setText("Boids:");
                jLabel3.setMaximumSize(new Dimension(210, 15));
                jLabel3.setMinimumSize(new Dimension(210, 15));
                jLabel3.setPreferredSize(new Dimension(210, 15));
                jLabel3.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel3.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel3.setLabelFor(obstacles);
                jLabel3.setText("Obstacles");
                jLabel4.setMaximumSize(new Dimension(210, 15));
                jLabel4.setMinimumSize(new Dimension(210, 15));
                jLabel4.setPreferredSize(new Dimension(210, 15));
                jLabel4.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel4.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel4.setLabelFor(behaviours);
                jLabel4.setText("Behaviours");
                jLabel6.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel6.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel6.setText("Base name:");
                jLabel7.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel7.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel7.setText("Number Of Entities:");
                baseName.setBorder(BorderFactory.createLoweredBevelBorder());
                baseName.setText("Toto");
                baseName.setHorizontalAlignment(SwingConstants.CENTER);
/*                nbEntities.setMaximum(50);
                nbEntities.setMinorTickSpacing(1);
                nbEntities.setPaintLabels(true);
                nbEntities.setPaintTicks(true);
		nbEntities.createStandardLabels(1);
                nbEntities.setForeground(Color.black);
                nbEntities.setBorder(BorderFactory.createLoweredBevelBorder()); */
                refreshBtn.setMaximumSize(new Dimension(32, 32));
                refreshBtn.setMinimumSize(new Dimension(32, 32));
                refreshBtn.setPreferredSize(new Dimension(32, 32));
                refreshBtn.setToolTipText("Refresh the lists of plugins");
                refreshBtn.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                refresh(e);
                        }
                });
                jLabel8.setHorizontalAlignment(SwingConstants.CENTER);
                jLabel8.setHorizontalTextPosition(SwingConstants.CENTER);
                jLabel8.setText("Refresh Plugins Lists");
                jPanel1.add(jLabel1,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(11, 74, 0, 0), 0, 0));
                jPanel1.add(addBtn,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 125, 9, 62), 8, 8));
                jPanel1.add(jLabel8,  new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(11, 32, 0, 0), 0, 0));
                jPanel1.add(refreshBtn,  new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(8, 89, 9, 55), 8, 8));
                jPanel1.add(jLabel2,  new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(11, 75, 0, 99), 0, 0));
                jPanel1.add(cancelBtn,  new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 73, 9, 107), 8, 8));
                this.getContentPane().add(jPanel3,  new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(33, 3, 0, 4), -9, 16));
                jPanel3.add(baseName,  new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 62, 3, 0), 136, 9));
                jPanel3.add(jLabel6,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(2, 100, 0, 38), 14, 1));
                jPanel3.add(jLabel7,  new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(2, 132, 0, 110), 27, 5));
                jPanel3.add(nbEntities,  new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 100, 3, 27), 83, 0));
                this.getContentPane().add(jPanel2,  new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 3, 0, 4), -9, -33));
                jPanel2.add(boids,  new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 15, 0, 0), 185, 196));
                jPanel2.add(obstacles,  new GridBagConstraints(2, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 21, 0, 13), 190, 197));
                jPanel2.add(behaviours,  new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 20, 0, 0), 194, 197));
                jPanel2.add(jLabel4,  new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(4, 25, 0, 0), -25, 27));
                jPanel2.add(jLabel3,  new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(4, 24, 0, 13), -25, 30));
                jPanel2.add(jLabel5,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(4, 15, 0, 0), -25, 20));
                this.getContentPane().add(jPanel1,  new GridBagConstraints(0, 2, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 3, 7, 4), -9, 24));
        }

        private void createEntities() {
                //System.out.println("Not yet Implemented!");
                Class c1 = null; // la classe du Boids
                Class c2 = null; // la classe de son comportement
                Entity E = null; // l'instance de Boids avec son comportement
                Object b[] = behaviours.getSelectedValues();

                if (boids.getSelectedValue() != null && b != null) {
                        obstacles.clearSelection();
                        System.out.println("vous voulez: " + nbEntities.getValue() + " " +
                                           boids.getSelectedValue() +
                                           " avec " + b.length + " comportements.");
                        for(int i = 0; i < nbEntities.getValue(); i++) {
                                try {
					c1 = boids.getSelectedValue().getClass();

                                        E = (Entity)c1.newInstance();
                                        E.setWorld(f.getPopulation());

                                        ((Boids)E).setWorldWidth(f.getWidth());
                                        ((Boids)E).setWorldHeigth(f.getHeight());
                                        ((Boids)E).setPath(((Boids)boids.getSelectedValue()).getPath());
                                        ((Boids)E).setPosX((int)(Math.random() * (f.getWidth() - 60) + 30));
                                        ((Boids)E).setPosY((int)(Math.random() * (f.getHeight() - 60) + 30));
                                        ((Boids)E).setSpeed(Math.random() * 5.0 + 1);
                                        ((Boids)E).setAccel(Math.random() * 1.5 + 0.5);
                                        ((Boids)E).setViewAngle(Math.random() * (Math.PI / 2));
                                        ((Boids)E).setHeading(Math.random() * 2 * Math.PI);
					boolean def = false;
                                        for (int j = 0; j < b.length; j++) {
						def = (((Behaviours)b[j]).getBehaviour().compareTo("Aleatoire") == 0);
						c2 = b[j].getClass();
                                                ((Boids)E).addBehaviour((Behaviours)c2.newInstance());
                                        }
					// on rajoute le comportement par dfaut si 'b.length == 0' ou s'il n'y est pas
					if ((! def) && (defaultBoidsBehaviour != null)) {
						c2 = defaultBoidsBehaviour.getClass();
						((Boids)E).addBehaviour((Behaviours)c2.newInstance());
					}
                                        ((Boids)E).setName(baseName.getText() + "_" + boidNum++);


                                        f.add(E);
                                } catch (Exception x) {
                                        System.err.println("[ERR] exception caught: " + x.getMessage());
                                }
                        }
                        boids.clearSelection();
                        behaviours.clearSelection();
                } else {
                        boids.clearSelection();
                        behaviours.clearSelection();
                        System.out.println("vous voulez: " + nbEntities.getValue() + " " +
                                           obstacles.getSelectedValue());

                        for(int i = 0; i < nbEntities.getValue(); i++) {
                                try {
					c1 = obstacles.getSelectedValue().getClass();
                                        E = (Entity)c1.newInstance();
//                                        E.setWorld(f);

                                        ((Obstacle)E).setPath(((Obstacle)obstacles.getSelectedValue()).getPath());
                                        ((Obstacle)E).setPosX((int)(Math.random() * (f.getWidth() - 60) + 30));
                                        ((Obstacle)E).setPosY((int)(Math.random() * (f.getHeight() - 60) + 30));

                                        f.add(E);

                                } catch (Exception x) {
                                        System.err.println("[ERR] exception caught: " + x.getMessage());
                                }
                        }

                        obstacles.clearSelection();
                }

        }

        void refresh(ActionEvent e) {
                refreshPluginsLists();
        }
}
