package GUI;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import java.net.URL;

import main.*;
import pluginSDK.Entity;
import utils.*;

/**
 * Title:        the Wondrous Farm
 * Description:	
 * Copyright:    Copyright (c) 2002
 * Company:      minfo
 */
public class Main3 extends JFrame {
        BorderLayout borderLayout1;
        JToolBar toolBar;
        TitledBorder titledBorder1;
        JButton quitBtn;
        JButton resetBtn;
        JButton addBtn;
        JButton aboutBtn;
        JButton helpBtn;
        JButton mapBtn;
        JButton statBtn;
        JButton pauseBtn;
        JButton saveBtn;
        JButton restoreBtn;
	JButton startBtn;
        JDesktopPane appDesk;
        private Flock world = null;
        private EntityCreator creator = null;
        private TWFHelpBrowser helpB = null;
        private JFileChooser fc = null;
        private JFrame Me;
	public static final boolean DEBUG = false;

        public Main3() {

                Me = this;
		
		borderLayout1 = new BorderLayout();
        	toolBar = new JToolBar();
        	quitBtn = new JButton();
        	resetBtn = new JButton();
        	addBtn = new JButton();
        	aboutBtn = new JButton();
        	helpBtn = new JButton();
        	mapBtn = new JButton();
        	statBtn = new JButton();
        	pauseBtn = new JButton();
        	saveBtn = new JButton();
        	restoreBtn = new JButton();
		startBtn = new JButton();
        	appDesk = new JDesktopPane();

                try {
                        jbInit();
                }
                catch(Exception e) {
			displayError(this.getClass(), "Main3() - jbInit()", e);
                }

                // world & wizard
                world = new Flock(640, 480);
		creator = new EntityCreator(world);
		creator.setResizable(true);
                world.addMouseListener(new EntitySelector(world, creator));
		appDesk.addMouseListener(new DeskListener(this.getContentPane()));
                appDesk.add(world);
		appDesk.add(creator);
                // fin world & wizard

                // boutons:
                addBtn.setIcon(new ImageIcon("icons/new.gif"));
                addBtn.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                creator.toFront();
				try {
					creator.setSelected(true);
				} catch (Exception x) {
					Main3.displayError(this.getClass(), "actionPerformed() - add", x);
				}
                        }
                });

                resetBtn.setIcon(new ImageIcon("icons/reset.gif"));
                resetBtn.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                System.out.println("Entering \"Genocid\" mode...");
                                world.empty();
                                System.out.println("done.");
                        }
                });

                statBtn.setIcon(new ImageIcon("icons/stats.gif"));
                statBtn.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                showStatsWindow();
                        }
                });

                aboutBtn.setIcon(new ImageIcon("icons/about.gif"));
                aboutBtn.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                showAboutWindow();
                        }
                });

                helpBtn.setIcon(new ImageIcon("icons/help.gif"));
                helpBtn.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
				if (helpB == null) {
					System.out.println("[INFO] loading help...");
					helpB = new TWFHelpBrowser(Me);
				}
				try {
					if (creator != null)
						creator.setSelected(false);
				} catch (Exception x) {
					Main3.displayError(this.getClass(), "actionPerformed() - help", x);
				}
				helpB.show();
                        }
                });
                quitBtn.setIcon(new ImageIcon("icons/quit.gif"));

                pauseBtn.setIcon(new ImageIcon("icons/pause.gif"));
                pauseBtn.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                world.pause();
                        }
                });

                saveBtn.setIcon(new ImageIcon("icons/save.gif"));
                saveBtn.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                saveSimulation();
                        }
                });

                restoreBtn.setIcon(new ImageIcon("icons/open.gif"));
                restoreBtn.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                restoreSimulation();
                        }
                });

		startBtn.setIcon(new ImageIcon("icons/start.gif"));
		startBtn.setToolTipText("Start simulation");
		startBtn.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                world.startSim();
                        }
                });

                // fin boutons
                this.setSize(700, 600);
                this.setVisible(true);
        }

        public static void main(String[] args) {
                try {
                        UIManager.setLookAndFeel("it.unitn.ing.swing.plaf.macos.MacOSLookAndFeel");
                } catch (Exception UIe) {
			displayError(GUI.Main3.class, "main()", UIe);
                }
                Main3 main31 = new Main3();
        }

        private void jbInit() throws Exception {
                titledBorder1 = new TitledBorder("");
                this.setDefaultCloseOperation(3);
                this.setTitle("The Wondrous Farm");
                this.getContentPane().setLayout(borderLayout1);
                toolBar.setBorder(titledBorder1);
                quitBtn.setToolTipText("Armaggedon ;-)");
                quitBtn.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                quitBtn_action(e);
                        }
                });
                resetBtn.setToolTipText("Reset World");
                addBtn.setToolTipText("Add entities to world");
                aboutBtn.setToolTipText("General Info");
                statBtn.setToolTipText("Display current Flock statistics");
                helpBtn.setToolTipText("Help about \"the Wondrous Farm\"");
                mapBtn.setToolTipText("Create a random map (with trees, houses, ...");
                pauseBtn.setToolTipText("Pause current simulation");
                saveBtn.setToolTipText("Save current simulation");
                restoreBtn.setToolTipText("Restore a saved simulation");
                this.getContentPane().add(toolBar, BorderLayout.NORTH);
                toolBar.add(quitBtn, null);
                toolBar.add(restoreBtn, null);
                toolBar.add(saveBtn, null);
                toolBar.add(new JToolBar.Separator(), null);
		toolBar.add(addBtn, null);
		toolBar.add(resetBtn, null);
		toolBar.add(startBtn, null);
		toolBar.add(pauseBtn, null);
		toolBar.add(statBtn, null);
                toolBar.add(new JToolBar.Separator(), null);
                toolBar.add(helpBtn, null);
                toolBar.add(aboutBtn, null);
                this.getContentPane().add(appDesk, BorderLayout.CENTER);
        }

        private void quitBtn_action(ActionEvent e) {
                System.out.println("ARMAGGEDON!!!...");
                System.exit(0);
        }

        private void showAboutWindow() {
                ImageIcon msg = new ImageIcon("icons/theWondrousFarm_AboutImg.jpg");
                JOptionPane.showInternalMessageDialog(appDesk, null, "About...",
                                                      JOptionPane.INFORMATION_MESSAGE, msg);
                creator.toBack();
        }

        private void showStatsWindow() {
                String msg = world.getFlockStats();
                JOptionPane.showInternalMessageDialog(appDesk, msg, "Statistics",
                                                      JOptionPane.INFORMATION_MESSAGE);
                creator.toBack();
        }

        private void saveSimulation() {
		if (fc == null) {
			fc = new JFileChooser(".");
			fc.setFileFilter(new MyFileFilter());
	                fc.setMultiSelectionEnabled(false);
		}
                int r = fc.showDialog(Me, "Save");
                if (r == JFileChooser.APPROVE_OPTION) {
                        PluginReaderWriter pw = new PluginReaderWriter(fc.getSelectedFile(), 'w', world);
                        pw.DO();
                }
		if (creator != null)
			creator.toBack();
        }

        private void restoreSimulation() {
		if (fc == null) {
			fc = new JFileChooser(".");
			fc.setFileFilter(new MyFileFilter());
	                fc.setMultiSelectionEnabled(false);
		}
                int r = fc.showOpenDialog(Me);
                if (r == JFileChooser.APPROVE_OPTION) {
                        PluginReaderWriter pr = new PluginReaderWriter(fc.getSelectedFile(), 'r', world);
                        pr.DO();
                }
		if (creator != null)
			creator.toBack();
        }

	/**
	 * Pour avoir des messages d'erreurs partout pareils
	 * @param c: la classe dans laquelle se trouve la mthode d'o vient l'erreur
	 * @param methodeName: le nom de la mthode o se trouve l'erreur
	 * @param e: l'exception leve par l'erreur.
	 */
	public static void displayError(Class c, String methodeName, Exception e) {
		System.err.println("[ERR] Exception caught in \"" + 
				   c.getName() + "." + methodeName +"\": " + 
				   e.getClass().getName() + " - " +e.getMessage());
		if (DEBUG)
                	e.printStackTrace();
	}
}
