package pluginSDK;

import main.*;

/**
 * Title:        the Wondrous Farm<br>
 * Description: La classe de base des plugins de comportement.<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 */
public abstract class Behaviours implements Plugin {

        private int type = Entity.IS_BEHAVIOUR;

	public Behaviours() {}

	/**
         * C'est la fonction qui implmente le comportement d'un boid.
         * @param Boids P: le boid qui <I>agit sur</I> l'autre
         * @param Entity T: la cible sur laquelle <code>P</code> agit.
         * @param Flock f: le monde de <code>P</code> et <code>T</code>
	 * @return boolean: <code>true</code> si l'tat de <code>b</code>  chang, <code>false</code> sinon
         */
        public abstract boolean actsOn(Boids P, Entity T, Flock f); // la mthode du comportement

        public String getKind() { return null; }

        public abstract String getBehaviour();

        public int getType() { return type; }

        public String toString() {
                String s = this.getClass().getName();
                return s.substring(s.indexOf(".") + 1, s.length());
        }



}
