package pluginSDK;

/**
 * Title:        the Wondrous Farm<br>
 * Description: L'interface des plugins du projet<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 * <p>Ce SDK contient entre autre trois classes abstraites:
 *  <ul><li>pluginSDK.Entity</li>
 *	<li>pluginSDK.Boids</li>
 *	<li>pluginSDK.Obstacle</li>
 *	<li>pluginSDK.Behaviours</li>
 * </ul>
 * </p>
 */
public interface Plugin extends java.io.Serializable {

        /**
         * Renvoie une constante entire qui permet de savoir si on affaire
         *  un Boids, un Obstacle, ...<br>
         * C'est pour faire un peu plus propre et plus lger que le <code>instanceof</code>
         * @return int: le type du Boid
         */
        public int getType();

        /**
         * Renvoie le type de Boids ou d'obstacles auquels on a affaire.
         * En fait on ne s'en set pas.
         * @return String: la description du type de Boids ou d'obstacles.
         */
        public String getKind();

        /**
         * Renvoie le type de comportement auquel on a affaire.
         * En fait on ne s'en set pas.
         * @return String: la description du comportement.
         */
        public String getBehaviour(); // pour les comportements

        /**
         * @return String: le nom  abrg (sans le <i>plugins</i>) du plugin.
         */
        public String toString(); // un quivalent de getType()
}
