package utils;

import java.io.InputStream;
import java.io.BufferedInputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.Properties;

/**
 * Title:        the Wondrous Farm<br>
 * Description:  lit le fichier de configuration du logiciel<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 * <p>Ce fichier de configuration contient les diffrentes URL
 * o on peut trouver les plugins dont se sert le logiciel. Sa
 * syntaxe est la suivante:</p>
 * <pre align='center'>
 * url1=emplacement2
 * url2=emplacement2
 * ...
 * urlN=emplacementN
 * </pre>
 */
public class Configurator extends Properties {

        /**
         * Charge le fichier de configuration pass en paramtres
         * @param fileName: l'URL complte (chemin + nom du fichier de configuation)
         */
        public Configurator(String fileName) {

                URL pathToConfigFile = null;

                try {
                        pathToConfigFile = new URL(fileName);
                        System.out.println("[INFO] url of config file: <<" + pathToConfigFile + ">>");
                } catch (Exception e) {
			GUI.Main3.displayError(this.getClass(), "Configurator() (I)", e);
                }
                try {
                        this.load(new BufferedInputStream(pathToConfigFile.openStream()));
                } catch (Exception e) {
			GUI.Main3.displayError(this.getClass(), "Configurator() (II)", e);
                }
        }

        /**
         * @return un tableau de <code>String</code> qui contient les diffrents chemins
         * vers les plugins.
         */
        public String[] getPluginsPath() {
                ArrayList path = new ArrayList();
                String[] pps = new String[1];
                int urlNb = 1;
                while (this.getProperty("url" + urlNb) != null)
                        path.add(this.getProperty("url" + urlNb++));
                pps = (String[])path.toArray(pps);
                return pps;
        }
}
