package utils;

import javax.swing.filechooser.FileFilter;
import java.io.File;

/**
 * Title:        the Wondrous Farm<br>
 * Description:  Le filtre qui permet de slectionner des fichier dans un <code>JFileChooser</code>.<br>
 *		 Ce filtre reconnait les fichiers avec une extension <i>.sim</i> (l'extension qui correspond
 *		  un fichier de simulation), les rpertoires et les fichiers cachs (ceux qui commencent par
 *		 <b>.</b><br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 */
public class MyFileFilter extends FileFilter {

        public MyFileFilter() { super(); }

        public boolean accept(File f) {
		return f.isDirectory() || f.getName().endsWith(".sim");
        }

        public String getDescription() {
                return "*.sim -- The Wondrous Farm simulation files";
        }
}
