package utils;

import java.lang.reflect.Method;
import java.util.ArrayList;

/**
 * Title:        the Wondrous Farm<br>
 * Description:  Cette classe permet de faire de dcrire un plugin par introspection.<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 */
public class PluginDescriptor {

        private Class clazz;
        private Method[] m;
        private Object p;
        private String desc;

	/**
	 * Le constructeur de descripteur.
	 * @param o: l'object dont on veut obtenir une description
	 */
	public PluginDescriptor(Object o) {
                clazz = o.getClass();
                p = o;
                m = clazz.getMethods();
                desc = null;
        }

	/**
	 * Renvoie la description de l'objet en se servant de tous ses <i>getters</i>.
	 * @return String: la chaine contenant la dscription
	 */
        public String getDesc() {
                desc = new String("");
                for(int i = 0; i < m.length; i++) {
                        try {
                                if ((m[i].getName().startsWith("get") || m[i].getName().startsWith("is")) &&
                                    m[i].getParameterTypes().length == 0)
                                        desc += (m[i].getName() + ": " + m[i].invoke(p, null) + "\n");
                        } catch (Exception e) {
				GUI.Main3.displayError(this.getClass(), "getDesc()", e);
                        }
                }

                return desc;
        }

	/**
	 * Renvoie une descroption comme <code>getDesc</code> mais adapte pour une sauvegarde
	 * de <code>Plugin</code> dans un fichier de texte.<br>
	 * Cette mthode n'est plus utilise puisque les plugins sont tous srializable.
	 * @return String: la chaine contenant la dscription
	 */
        public String getDescForSave() {
                String save = "Plugin {\n";
                for(int i = 0; i < m.length; i++) {
                        try {
                                if ((m[i].getName().startsWith("get") || m[i].getName().startsWith("is")) &&
                                    m[i].getParameterTypes().length == 0)
                                        save += ("\t" + m[i].getName() + ": " + m[i].invoke(p, null) + ";\n");
                        } catch (Exception e) {
				Main3.displayError(this.getClass(), "getDescForSave()", e);
                        }
                }
                save += "} // endPlugin\n\n";

                return save;
        }
}
