package utils;

import com.sun.media.sound.JavaSoundAudioClip;
import java.io.InputStream;
import java.net.URL;

/**
 * Title:        the Wondrous Farm<br>
 * Description: Classe permettant de jouer des sons de type WAV, AU ou MIDI.<br>
 * Copyright:    Copyright (c) 2002<br>
 * Company:      minfo<br>
 */
public class SoundPlayer extends Thread implements java.io.Serializable {

        private InputStream ais;
        private JavaSoundAudioClip clip;

        /**
	 * L'URL passe en paramtre contient bien sur le fichier son.<br>
	 * Si on veut jouer le fichier <code>toto.wav</code> qui se trouve dans 
	 * <code>C:\MesSons</code>, l'URL est <code>file:/C:/MesSons/toto.wav</code>
         * @param sndURL: l o se trouve le fichier sonore.
         */
        public SoundPlayer(URL sndURL) {
                try {
                        ais = sndURL.openStream();
                        clip = new JavaSoundAudioClip(ais);
                } catch (Exception e) {
                        System.err.println("[ERR] Exception caught: " + e.getMessage());
                        e.printStackTrace();
                }
        }

        /**
         * Jouer le son.
         */
        public void play() {
                clip.play();
        }

        /**
         * Arrter de le jouer.
         */
        public void stopPlaying() {
                clip.stop();
        }

}
